PRO OVEL3,data,ima,reb,scale

;Visualization of average velocities computed by OTROK.
;Inputs: data  - resulting array of otrok
;	 ima   - underlying image (e.g. aver(41:110,71:140))
;	 reb   - rebinning factor
;	 scale - scaling factor km/s - arrow length

s=size(data)
scale=scale*reb
window,2,xsize=240*reb,ysize=240*reb
tvscl,rebin(ima,240*reb,240*reb)

for i=0,s(2)-1 do begin
  x0=data(1,i)*reb	;beginning - average position
  y0=data(2,i)*reb
  x1=x0+data(3,i)*scale	;end - velocity magnitude
  y1=y0+data(5,i)*scale
  arrow,x0,y0,x1,y1,thick=2,hsize=4,col=0
endfor
  arrow,200*reb,5*reb,200*reb+scale,5*reb,thick=2,hsize=4,col=0
	;scale 1 km/s

END
